
#ifndef P3D_H
#define P3D_H

#ifdef __cplusplus
extern "C" {
#endif

/* Scene rendering */

extern int _pixels3d;       /* This is for performance measurments */
extern int scene_pix_count;
extern float scene_gap;

int scene_start(BITMAP *bmp, int nedge, int npoly);
int scene_polygon3d(int type, BITMAP *texture, int vx, V3D *vtx[]);
int scene_polygon3d_f(int type, BITMAP *texture, int vx, V3D_f *vtx[]);
void scene_render();

/* Z-buffer */

/* comment out if you don't want ZBUF */
#define USE_ZBUF

#define POLYTYPE_ATEX_TRANS             11
#define POLYTYPE_PTEX_TRANS             12
#define POLYTYPE_ATEX_MASK_TRANS        13
#define POLYTYPE_PTEX_MASK_TRANS        14
#define POLYTYPE_ZBUF                   256

extern BITMAP *zbuf_bmp;
extern int zbuf_pix_count;

int zbuf_start(BITMAP *bmp, float z);

/* Matrix */

typedef struct MATRIX_al
{
   float data[16];
} MATRIX_al;

void build_matrix_al(MATRIX_f *in, MATRIX_al *out);
void apply_matrix_3dnow(MATRIX_al *m, float x, float y, float z,
                        float *xout, float *yout, float *zout);
void persp_project_3dnow(float x, float y, float z, float *xout, float *yout);
void normalize_vector_3dnow(float *x, float *y, float *z);

#ifdef __cplusplus
}
#endif

#endif

